#include<iostream>
#include<algorithm>
#include<vector>
#include<map>
#include<deque>

using namespace std;

typedef long long ll;
typedef pair<int, int> ii;

int n, m;
vector<vector<bool>> lights;
vector<vector<int>> dist;
vector<vector<int>> columns;
vector<vector<bool>> done;


int main(){
	//ios::sync_with_stdio(false);
	cin >> n >> m;
	int x, y;

	lights.resize(n, vector<bool>(n, false));
	done.resize(n, vector<bool>(n+1, false));
	dist.resize(n, vector<int>(n+1, -1));
	columns.resize(n);

	for(int i = 0; i < m; ++i){
		cin >> x >> y;
		--x; --y;
		lights[x][y] = true;
		columns[x].push_back(y);
	}


	dist[0][0] = 0;

	deque<ii> q;
	q.push_back({0,0});
	//int cnt = 0;

	//cerr << "Matfzy: " << matfyz << ", kolej: " << kolej << endl;


	while(!q.empty()){
		auto cur = q.front();
		q.pop_front();
		x = cur.first;
		y = cur.second;
		if(done[x][y]) continue;
		done[x][y] = true;

		//cerr << x << " " << y << ": " << dist[x][y] << endl;

		if(y == n){
			for(auto ny : columns[x]){
				if(!lights[x][ny]) continue;
				if(dist[x][ny] != -1) continue;
				dist[x][ny] = dist[x][y];
				q.push_front({x, ny});
			}
		} else{
			vector<ii> to_visit;
			to_visit.push_back({x-1,y});
			to_visit.push_back({x+1,y});
			to_visit.push_back({x,y-1});
			to_visit.push_back({x,y+1});
			to_visit.push_back({x+1,n});

			for(auto nw : to_visit){
				int nx = nw.first,
					ny = nw.second;
				if(nx < 0 ||
					ny < 0 ||
					nx >= n ||
					ny > n) continue;
				if(dist[nx][ny] != -1) continue;
				if(ny != n && !lights[nx][ny]) continue;
				dist[nx][ny] = dist[x][y];
				if(ny == n){
					++dist[nx][ny];
					q.push_back(nw);
				} else{
					q.push_front(nw);
				}
			}
		}
		
	}




	cout << dist[n-1][n-1] << endl;
	//cerr << cnt << endl;


	return 0;
}