#include <vector>
#include <set>
#include <iostream>
#include <tuple>

using namespace std;

int n, m;
vector<vector<int>> rozsviceno;

int dfs(int x, int y) {
    if (x < 0 || y < 0 || x >= n || y >= n || rozsviceno[x][y] == 0) {
        return -1;
    }
    rozsviceno[x][y] = 0;
    if (x == n-1 && y == n-1) {
        return n;
    }
    int dx=1, dy=0;
    int nejdale = x;
    for (int i=0; i<4; i++) {
        nejdale = max(nejdale, dfs(x+dx, y+dy));
        tie(dx, dy) = make_pair(-dy, dx);
    }
    return nejdale;
}

int main() {
    cin >> n >> m;
    rozsviceno.resize(n);
    for (int i=0; i<n; i++) {
        rozsviceno[i].resize(n, 0);
    }
    int a, b;
    for (int i=0; i<m; i++) {
        cin >> a >> b;
        a--; b--;
        rozsviceno[a][b] = 1;
    }
    int rozsviceni = 0;
    int posledni = -1;
    int ted = dfs(0, 0);
    while (posledni < ted && ted < n) {
        rozsviceni++;
        for (int i=0; i<n; i++) {
            rozsviceno[ted][i] = 1;
        }
        posledni = ted;
        ted = dfs(ted, 0);
    }
    if (ted == n) {
        cout << rozsviceni << endl;
    } else {
        cout << -1 << endl;
    }
}